Befehlstabelle:	C00:	jmp   	Normal			;Wird nie vom Controller gesendet, da das der Code fr nichts senden ist...
				C01:	jmp   	Normal
				C02:	jmp		Normal
				C03:	jmp   	Identify
				C04:	jmp	  	Challenge
				C05:	jmp   	Serialnumber
				C06:	jmp	  	Normal
				C07:	jmp   	Normal			

;-------------------------------------------------------------------------------------------------------
Normal:			Set_TWI_Mode 1
ret

;------------------------------------------------------------------------------------------------------------
Identify:		Set_TWI_Mode 3
				ld_Z	ID_Start*2
				ld_X	TWI_Buffer
	IDL:		lpm 	t1,Z+
				st		X+,t1
				cpi		ZH,high(ID_End*2)	brne IDL
				cpi		ZL,low(ID_End*2)	brne IDL				
ret

;-------------------------------------------------------------------------------------------------------
Challenge:		Set_TWI_Mode 4
				ld_Z	Challenge_Start*2
				ld_X	TWI_Buffer
	CDL:		lpm 	t1,Z+
				st		X+,t1
				cpi		ZH,high(Challenge_End*2)	brne CDL
				cpi		ZL,low(Challenge_End*2)		brne CDL
ret

;------------------------------------------------------------------------------------------------------------
Serialnumber:	Set_TWI_Mode 5
				ld_Z	0x0E				;Startadresse der Seriennummer in der Sigrow
				ld_X	TWI_Buffer				
	SNL:		st_v	SPMCSR,0b00100001	;LPM umschalten auf lesen der Sigrow	
				lpm		t1,Z+				;10 Byte Seriennummer
				st		X+,t1
				cpi		ZL,0x18		brne SNL
				st		X+,r_Zero			;Rest auffllen
				st		X+,r_Zero				
ret

;-------------------------------------------------------------------------------------------------------
Pause:			push	t1
				clr		t1
Pausenloop:		dec		t1		brne	Pausenloop
				pop		t1
ret

;-------------------------------------------------------------------------------------------------------
Reset_TWI_Bus:	push	t1					;t1 wird von st_v verwendet...
				st_v 	TWCR,TWI_Reset
				rcall	Pause
				st_0 	TWCR
				rcall	Pause
				st_v 	TWCR,TWI_Reset
				rcall	Pause
				st_0 	TWCR
				rcall	Pause
				st_v	TWCR,TWI_Enable
				st_v	TCCR1B,0b00000100	;LED Blinken an...
				Set_TWI_Mode 1
				pop		t1
ret